#include <t_services.h>
#include <serial.h>
#include "kernel_id.h"

#include "ff.c"
#include "mmc.c"
#include "main.h"

//------------------------------------------------------------------------------
//
//	Хѿ
//
//------------------------------------------------------------------------------

FATFS fs;

//------------------------------------------------------------------------------
//
//	Ƽ磻٥ȥϥɥ
//
//------------------------------------------------------------------------------

//ü٥
void cyclic_handler(VP_INT exinf)
{
	iact_tsk(MSG_TASK);
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//
//	å
//
//------------------------------------------------------------------------------

//å
void MessageTask(VP_INT exinf)
{
	FIL fp;
	FRESULT res;
	
	res = f_open(&fp, "test.txt", FA_WRITE | FA_OPEN_ALWAYS);
	if ( res==FR_OK ) {
		
		f_lseek(&fp, fp.fsize);
		f_puts("this is a test.\r\n", &fp);
	}
	f_close(&fp);
	
	ext_tsk();
}
//------------------------------------------------------------------------------


//------------------------------------------------------------------------------
//
//	ᥤץ
//
//------------------------------------------------------------------------------

//ȥ꡼ݥ
void MainTask(VP_INT exinf)
{
	//ץν
	InitProgram();
	
	
	//ᥤ롼
	while ( TRUE ) {
		slp_tsk();
	}
	
	kernel_exit();
}
//------------------------------------------------------------------------------

//ץν
void InitProgram()
{
	serial_opn_por(1);
	
	//FatFs
	sta_cyc( CYCHDR1 );
	f_mount(0, &fs);
}
//------------------------------------------------------------------------------
DWORD get_fattime ()
{
	return	  ((DWORD)(2008 - 1980) << 25)
			| ((DWORD)5 << 21)
			| ((DWORD)14 << 16)
			| ((DWORD)3 << 11)
			| ((DWORD)23 << 5)
			| ((DWORD)0 >> 1);
}


